=== debian/changelog ===
ring (20210112.2.b757bac~ds1-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 28 Jun 2021 12:31:32 -0700

ring (20210112.2.b757bac~ds1-1) unstable; urgency=medium

  [ Alexandre Viau ]
  * New upstream snapshot.
  * d/copyright: ignore ONNX Runtime.

  [ Thorsten Alteholz ]
  * CVE-2020-15260 (Closes: #986815)
    Adding remote hostname authentication when reusing transport
    connections to the same IP address.
  * CVE-2021-21375
    The embedded copy of pjproject is affected by this CVE.
    Due to bad handling of two consecutive crafted answers to an INVITE,
    the attacker is able to crash the server resulting in a denial of
    service.

  [ Amin Bandali ]
  * d/patches: add upstream patch for fixing SIP calls to zoom.
    (Closes: #980571)
  * d/patches: add patch for improving the appstream description.

  [ Bruno Kleinert ]
  * d/control: improve package description. (Closes: #979492)

 -- Alexandre Viau <aviau@debian.org>  Sun, 17 Jan 2021 16:39:58 -0500
