=== debian/control ===
Source: ring
Section: comm
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Viau <aviau@debian.org>
Build-Depends: autoconf,
               automake,
               cmake,
               debhelper (>= 9),
               gettext,
               libarchive-dev,
               libargon2-0-dev,
               libasio-dev,
               libasound2-dev,
               libavcodec-dev,
               libavdevice-dev,
               libavformat-dev,
               libavutil-dev (>= 7:3.4.2),
               libayatana-appindicator3-dev | libappindicator3-dev,
               libcanberra-gtk3-dev,
               libclutter-1.0-dev,
               libclutter-gtk-1.0-dev,
               libcrypto++-dev,
               libdbus-1-dev,
               libdbus-c++-dev,
               libexpat1-dev,
               libfmt-dev,
               libglib2.0-dev,
               libgnutls28-dev (>= 3.4.14),
               libgsm1-dev,
               libgtk-3-dev,
               libhttp-parser-dev,
               libjsoncpp-dev,
               libmsgpack-dev (>= 1.4.2),
               libnatpmp-dev,
               libnm-dev,
               libnotify-dev,
               libopendht-dev (>= 2.1.1),
               libopus-dev,
               libpcre3-dev,
               libpulse-dev,
               libqrencode-dev,
               libsamplerate0-dev,
               libsecp256k1-dev,
               libsndfile1-dev,
               libspeex-dev,
               libspeexdsp-dev,
               libssl-dev,
               libswscale-dev,
               libtool,
               libudev-dev,
               libupnp-dev,
               libva-dev,
               libvdpau-dev,
               libwebkit2gtk-4.0-dev,
               libxext-dev,
               libxfixes-dev,
               libyaml-cpp-dev,
               qtbase5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               uuid-dev,
               yasm
Standards-Version: 4.5.1
Homepage: https://jami.net
Vcs-Git: https://salsa.debian.org/pkg-voip-team/ring.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/ring
Rules-Requires-Root: no

Package: jami
Architecture: any
Depends: jami-daemon (=${binary:Version}),
         libqt5sql5-sqlite,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: ring (<< 20190101.3.5315d84~)
Breaks: ring (<< 20190101.3.5315d84~)
Description: Secure and distributed voice, video, and chat platform - desktop client
 Jami is an end-to-end encrypted secure and distributed voice, video,
 and chat communication platform that requires no central server and
 leaves the power of privacy and freedom in the hands of users.
 .
 To some degree Jami provides similar functionality like Telegram,
 BigBlueButton, Jitsi Meet, etc do.
 .
 Jami supports the following key features:
   * One-to-one conversations
   * File sharing
   * Audio calls and conferences
   * Video calls and conferences
   * Screen sharing in video calls and conferences
   * Recording and sending audio messages
   * Recording and sending video messages
   * Functioning as a SIP phone software
 .
 Jami client applications for several desktop and mobile operating
 systems and platforms are available on https://jami.net/, making
 Jami an interoperable, cross-platform communication framework.
 .
 This package contains the Jami desktop client: jami-gnome.

Package: jami-daemon
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: ring-daemon (<< 20190101.3.5315d84~)
Breaks: ring-daemon (<< 20190101.3.5315d84~)
Description: Secure and distributed voice, video and chat platform - daemon
 Jami is an end-to-end encrypted secure and distributed voice, video,
 and chat communication platform that requires no central server and
 leaves the power of privacy and freedom in the hands of users.
 .
 To some degree Jami provides similar functionality like Telegram,
 BigBlueButton, Jitsi Meet, etc do.
 .
 Jami supports the following key features:
   * One-to-one conversations
   * File sharing
   * Audio calls and conferences
   * Video calls and conferences
   * Screen sharing in video calls and conferences
   * Recording and sending audio messages
   * Recording and sending video messages
   * Functioning as a SIP phone software
 .
 Jami client applications for several desktop and mobile operating
 systems and platforms are available on https://jami.net/, making
 Jami an interoperable, cross-platform communication framework.
 .
 This package contains the Jami daemon: dring.
